/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "lcd_hd44780_lib.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
typedef enum {FALSE = 0, TRUE = !FALSE} bool;
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
unsigned char buforRx[17]={0};
unsigned char bufRxIndex=0;
bool odebranoDane=FALSE;
unsigned char buforTx[20]={"Stan diod: ........\0"};
unsigned char bufTxIndex=0;
bool OdbiorStatusu=FALSE; //czy odbierany jest status BLE

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_NVIC_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
  unsigned int i;
  unsigned short int stanGPIOB;
  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_USART1_UART_Init();

  /* Initialize interrupts */
  MX_NVIC_Init();
  /* USER CODE BEGIN 2 */

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */

  LCD_Initialize();                           //inicjalizacja wyswietlacza
  LCD_WriteCommand(HD44780_CLEAR);            //wyczysc wyswietlacz
  HAL_GPIO_WritePin(GPIOA, GPIO_PIN_11, GPIO_PIN_SET);

  HAL_UART_Receive_IT(&huart1, &buforRx[bufRxIndex], 1); //rozpocznij nasluch pierwszego znaku, gdy nadejdzie, wejdziemy w obsluge przerwania
  while (1)
  {
    if (odebranoDane){
	  LCD_WriteCommand(HD44780_CLEAR);      //wyczysc wyswietlacz
	  LCD_WriteText((char *)buforRx);       //wyswietl zawarotsc bufora
	  odebranoDane=FALSE;

	  switch (buforRx[0]){
	          case 0x4C:                                     //Pierwszy znak == l lub L
	          case 0x6C: { if (buforRx[1]=='+'){             //Drugi znak == +
                              if ((buforRx[2]>='1') && (buforRx[2]<='8'))   //zabezpieczenie przed numerem diody spoza zakresu 1...8
	        	                 GPIOB->BSRR= 0x0100 << (buforRx[2]-48-1);
	                       }
	                       if (buforRx[1]=='-'){             //Drugi znak == -
	                          if ((buforRx[2]>='1') && (buforRx[2]<='8'))   //zabezpieczenie przed numerem diody spoza zakresu 1...8
	                             GPIOB->BRR= 0x0100 << (buforRx[2]-48-1);
	                       }
	                     } break;
	          case 0x3F: {                                   //Pierwszy znak == ?
	                     //Pobierz stan portu
	                     stanGPIOB=GPIOB->ODR;
	                     //LEDowi 1 odpowiada pozycja 8, wiec przesun stan o 8 pozycji w prawo
	                     stanGPIOB=stanGPIOB>>8;
	                     //Sprawdzaj kolejne bity stanu portu
	                     //wstawiaj symbol stanu diody od prawej, tak, by LED 1 byl
	                     //na ostatnim znaku co odpowiada pozycji LED1 na ZL27ARM
	                     for (i=0;i<8;i++){
	                       if ((stanGPIOB&0x0001)==1){
	                         buforTx[18-i]='O';
	                       } else {buforTx[18-i]='.';}
	                       //Przesun o jeden w prawo, by sprawdzic kolejna diode
	                       stanGPIOB=stanGPIOB>>1;
	                     }
	                     //Dodanie znacznika nowej linii = znak konca transmisji
	                     buforTx[19]=0x0D;
	                     //Rozpocznij transmisje calego tekstu, 19 znakow
	                     HAL_UART_Transmit_IT(&huart1, buforTx, 20);
	                   } break;
	  }

	}

	HAL_Delay(200);
	//HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_15);

    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief NVIC Configuration.
  * @retval None
  */
static void MX_NVIC_Init(void)
{
  /* USART1_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(USART1_IRQn, 1, 0);
  HAL_NVIC_EnableIRQ(USART1_IRQn);
}

/* USER CODE BEGIN 4 */
void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart){
  if (huart->Instance==USART1){
	if(buforRx[bufRxIndex] == 0x0D) { //Wykrycie znaku /CR
	  odebranoDane = TRUE;

	  //wyzerowanie znakow do konca bufora
	  //(zabezpiecza przed wyswietlaniem "smieci" na LCD)
	  while (bufRxIndex<17) {
		buforRx[bufRxIndex]=0;
		bufRxIndex++;
	  }
	  bufRxIndex = 0;
	} else {                        //Obsluga pozostalych znakow
	  if(buforRx[bufRxIndex] == 0x25){ //jesli znak % to znaczy ze modul BLE zaczyna lub konczy wysylac informacje o statusie (np. info o polaczeniu).
		                               //Status bedzie ignorowanyy - czekamy na zamykający znak %. Pierwszy % zaczyna status, drugi % konczy status.
		OdbiorStatusu=!OdbiorStatusu;  //przelacz na co drugim %
		buforRx[bufRxIndex]=0;         //usun znak % z bufora
		bufRxIndex--;                  //cofnij licznik znakow o 1
	  }
	  if (!OdbiorStatusu){             //odczyt znakow jesli nie jestesmy w trybie ignorowania statusu
	    bufRxIndex++;
	    //Zabezpieczenie przed przepelnieniem bufora jesli odbierany tekst
	    //jest dluzszy niz 16 znakow
	    if (bufRxIndex>16){
  		  bufRxIndex=0;
	    }
	  }
	}
	HAL_UART_Receive_IT(&huart1, &buforRx[bufRxIndex], 1);
  }
}

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
