/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "i2c.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "mems2_i2c_lib.h"
#include "lcd_hd44780_lib.h"
#include "stdlib.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
  signed char x, y, z;
  char Tekst[7] = {""};
  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  /* USER CODE BEGIN 2 */

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  LCD_Initialize();                           //inicjalizacja wysietlacza
  LCD_WriteCommand(HD44780_CLEAR);            //wyczysc wyswietlacz

  LIS35_I2C_HwConfig();
  if (LIS35_I2C_Init(2)==LIS35_OK){           //inicjalizacja akcelerometru
	LCD_WriteTextXY("LIS35 - OK\0",0,0);      //akceleromatr zainicjalizowany
  } else {
    LCD_WriteTextXY("LIS35 - Error\0",0,0);   //blad inicjalizacji akcelerometru
  }
  HAL_Delay(2000);

  LCD_WriteCommand(HD44780_CLEAR);            //wyczysc wyswietlacz
  LCD_WriteTextXY("X: \0",0,0);
  LCD_WriteTextXY("Y: \0",8,0);
  LCD_WriteTextXY("Z: \0",0,1);

  //korekty i rzeczywiste czulosci poszczegolnych kanalow dla danego egzemplarza ukladu LIS35
  //uklad w trybie pracy +-2g
  //standardowa korekta = 0, czulosc 1800
  #define xKor -4     //-(odczytana wartosc przy pol poziomym)
  #define yKor 2
  #define zKor 1
  #define xCzul 1751  //9.8067g / ((wartosc przy polozeniu "+1g" - wartosc przy polozeniu "-1g") / 2) * 10000
  #define yCzul 1783
  #define zCzul 1767
  while (1)
  {
	LIS35_I2C_GetXYZacc( &x, &y, &z);
	x+=xKor;
	y+=yKor;
	z+=zKor;
	//sprintf(Tekst, "%3d ", x);
	sprintf((char*)Tekst, " %1d.%02d", abs((x*xCzul)/98067), abs(((x*xCzul*100)/98067)%100));
	if (x<0) Tekst[0]='-';
	LCD_WriteTextXY(Tekst,2,0);
	//sprintf(Tekst, "%3d ", y);
	sprintf((char*)Tekst, " %1d.%02d", abs((y*yCzul)/98067), abs(((y*yCzul*100)/98067)%100));
	if (y<0) Tekst[0]='-';
	LCD_WriteTextXY(Tekst,10,0);
	//sprintf(Tekst, "%3d ", z);
	sprintf((char*)Tekst, " %1d.%02d", abs((z*zCzul)/98067), abs(((z*zCzul*100)/98067)%100));
	if (z<0) Tekst[0]='-';
	LCD_WriteTextXY(Tekst,2,1);

	HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_15);
	HAL_Delay(250);

    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
