/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "i2c.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "lcd_hd44780_lib.h"
#include "lps25hb_i2c_lib.h"
#include "stdlib.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
typedef enum {FALSE = 0, TRUE = !FALSE} bool;

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
  short int temperatura=0;
  int cisnienie=0;
  bool pomiarWzgledny=FALSE;
  char temperaturaTekst[13]={"   0,0 C"};
  char cisnienieTekst[13]  ={"   0,0 hpa"};
  const char stopienSymbol[8] = {0x06, 0x09, 0x09, 0x06, 0x00, 0x00, 0x00,0};   //symbol stopnia

  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  /* USER CODE BEGIN 2 */

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  LCD_Initialize();                                         //Inicjalizacja wyswietlacza
  LCD_SetUserChar(1, 1, stopienSymbol);                     //Rejestracja symbolu stopnia
  LCD_WriteCommand(HD44780_CLEAR);                          //Wyczysc wyswietlacz

  LPS25_I2C_HwConfig();
  //if (LPS25_I2C_Init(Rate_OneShot)==LPS25_OK){            //inicjalizacja barometru w trybie OnShot
  if (LPS25_I2C_Init(Rate_7Hz)==LPS25_OK){                  //inicjalizacja barometru do pracy z zadana czestotliwoscia pomiaru
  	LCD_WriteTextXY("LPS25 - OK\0",0,0);                    //barometr zainicjalizowany
  } else {
    LCD_WriteTextXY("LPS25 - Error\0",0,0);                 //blad inicjalizacji barometru
  }

  //LPS25_I2C_SetFIFOMode(Mean, WTM_16);                     //Tryb sredniej z 16 pomiarow

  HAL_Delay(2000);
  LCD_WriteCommand(HD44780_CLEAR);                          //Wyczysc wyswietlacz
  LCD_WriteTextXY("C:      0,0 hpa",0,0);
  LCD_WriteTextXY("T:      0,0  C",0,1);


  while (1)
  {
	LPS25_I2C_GetPress(&cisnienie);
	LPS25_I2C_GetTemp(&temperatura);

	sprintf((char*)cisnienieTekst, " %4d.%02d hpa", abs((cisnienie)/4096), abs(((cisnienie*100)/4096)%100));
	if (cisnienie<0) cisnienieTekst[0]='-';
	LCD_WriteTextXY(cisnienieTekst,3,0);

	sprintf((char*)temperaturaTekst, " %4d.%02d C", abs((20400+(int)temperatura)/480), abs((((20400+(int)temperatura)*100)/480)%100));
	if (((20400+(int)temperatura)/480)<0) temperaturaTekst[0]='-';
	temperaturaTekst[9]=1;
	LCD_WriteTextXY(temperaturaTekst,3,1);

	if (!HAL_GPIO_ReadPin(GPIOA,GPIO_PIN_0)){
	  if (pomiarWzgledny){
	    pomiarWzgledny=FALSE;
		LPS25_I2C_Autozero(LPS25_DISABLE);
		HAL_GPIO_WritePin(GPIOB,GPIO_PIN_8,GPIO_PIN_RESET);
	  } else {
		pomiarWzgledny=TRUE;
		LPS25_I2C_Autozero(LPS25_ENABLE);
		HAL_GPIO_WritePin(GPIOB,GPIO_PIN_8,GPIO_PIN_SET);
	  }
	}

	if (!HAL_GPIO_ReadPin(GPIOA,GPIO_PIN_3)){ //wyzwolanie pomiaru w trybie OneShot
	  LPS25_I2C_DoOneShot();
	}

	HAL_Delay(200);
	HAL_GPIO_TogglePin(GPIOB,GPIO_PIN_15);

    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
